const makeIterator = (array) => {
	let index = 0;

	return {
		next(reset) {
			if (reset) {
				index = 0;
			}
			if (index < array.length) {
				return {
					value: array[index++],
					done: false
				}
			}

			return {
				value: undefined,
				done: true
			}
		}
	}
}

const iterator = makeIterator(['a', 'b', 'c']);
console.log(iterator.next())
console.log(iterator.next())
console.log(iterator.next(true))
console.log(iterator.next())
console.log(iterator.next())